//   
enum spawnWeap
{
	 _id, _ammo, _money, _isEnabled
}

new SpawnWeapMag[numBaseWeap][numWeapsInMag][spawnWeap];

//   
const MC_numTypesCars = 4;
const MC_numCrasInSlot = 10;

const MC_SlotName_MaxLen = 30;

new MC_slotNames[MC_numTypesCars][MC_SlotName_MaxLen];          //   

new MC_Cars[MC_numTypesCars][MC_numCrasInSlot];                 //  
//MC_MagazineConf
LoadCUPWeapMag()
{
	if(!fexist(CUPweapMagPatch))
	{
		 printf("      ");
		 SaveToLog("      .", 0);
		 return false;
	}
	new tmp[256];
	new tmp2[256];
	new t[20][50];
	for(new i=0; i<numBaseWeap; i++)
	  for(new k=0; k<numWeapsInMag; k++)
	  {
		  format(tmp, sizeof(tmp), "Slot_%d_%d", i, k);
		  if(!dini_Isset(CUPweapMagPatch, tmp))
		  {
			 for(new j=k; j<numWeapsInMag; j++) SpawnWeapMag[i][j][_isEnabled] = 0;
	         break;
		  }
		  tmp2 = dini_Get(CUPweapMagPatch, tmp);
          split(tmp2, t, ',');
          SpawnWeapMag[i][k][_isEnabled] = 1;
          SpawnWeapMag[i][k][_id] = strval(t[0]);
          SpawnWeapMag[i][k][_ammo] = strval(t[1]);
          SpawnWeapMag[i][k][_money] = strval(t[2]);
	  }
	return true;
}

// .   10
NextArmourValue(playerid)
{
	if(PlayerParams[playerid][BodyArmor] < 10) return 20000;
	if(PlayerParams[playerid][BodyArmor] < 20) return 40000;
	if(PlayerParams[playerid][BodyArmor] < 30) return 100000;
	if(PlayerParams[playerid][BodyArmor] < 40) return 160000;
	if(PlayerParams[playerid][BodyArmor] < 50) return 200000;
	if(PlayerParams[playerid][BodyArmor] < 60) return 250000;
	if(PlayerParams[playerid][BodyArmor] < 70) return 300000;
	if(PlayerParams[playerid][BodyArmor] < 80) return 500000;
	if(PlayerParams[playerid][BodyArmor] < 90) return 1000000;
	if(PlayerParams[playerid][BodyArmor] < 100) return 2000000;
	return 20000000;
}

GetNumWeapInWMagSlot(numSlot)
{
	if((numSlot < 0) || (numSlot >= numBaseWeap)) return 0;
	new num = 0;
	for(new i=0; i<numWeapsInMag; i++)
	   if(SpawnWeapMag[numSlot][i][_isEnabled] == 0) return num;
	   else num++;
	return num;
}

Load_MC()
{
	if(!fexist(MC_MagazineConf))
	{
		 printf("      ");
		 SaveToLog("      .", 0);
		 return false;
	}
	new tmp[256];
	new tmp2[256];
    for(new i=0; i<MC_numTypesCars; i++)
    {
		format(tmp, sizeof(tmp), "Slot_%d_name", i);
		if(!dini_Isset(MC_MagazineConf, tmp))
		{
		  format(tmp, sizeof(tmp), "     %d    ", i);
		  printf("     ");
		  SaveToLog(tmp, 0);
		  return false;
	    }
	    tmp2 = dini_Get(MC_MagazineConf, tmp);
	    format(MC_slotNames[i], MC_SlotName_MaxLen, "%s", tmp2);
    }
    
	for(new i=0; i<MC_numTypesCars; i++)
	{
	  for(new k=0; k<MC_numCrasInSlot; k++)
	  {
		  format(tmp, sizeof(tmp), "V_%d_%d", i, k);
		  MC_Cars[i][k] = dini_Int(MC_MagazineConf, tmp);
	  }
	  printf(" :  %d    %d", MC_NumVInSlot(i), i);
	}
	return true;
}

MC_NumVInSlot(numSlot)
{
   if((numSlot < 0) || (numSlot >= MC_numTypesCars)) return 0;
   for(new k=MC_numCrasInSlot-1; k>=0; k--)
	   if(isVehModelCorrectly(MC_Cars[numSlot][k])) return k+1;
   return 0;
}
