const MaxLvls = 100;                //  
const Max_Exp_Lvl_Name = 20;        //   
enum _LvlsDescriptor
{
	MaxExpForNextLvl,               //      
	MaxMoneyForLvls,                //     
	LvlName[Max_Exp_Lvl_Name]       // 
}

new ExpLevels[MaxLvls][_LvlsDescriptor];

new MaxExpLevel;                   //   

//        
new ExpforDiffLvl[MaxLvls];

LoadExpLevels()
{
   MaxExpLevel=0;
   new tmp1[50];
   new tmp2[256];
   new t[10][50];
   //ExpLvlsPatch
   if(!fexist(ExpLvlsPatch)) return;
   while(MaxExpLevel < MaxLvls)
   {
      format(tmp1, sizeof(tmp1), "Lvl_%d", MaxExpLevel);
      if(!dini_Isset(ExpLvlsPatch, tmp1)) break;
      tmp2 = dini_Get(ExpLvlsPatch,tmp1);
      split(tmp2, t, ',');
      ExpLevels[MaxExpLevel][MaxExpForNextLvl] = strval(t[0]);
      ExpLevels[MaxExpLevel][MaxMoneyForLvls] = strval(t[1]);
      format(ExpLevels[MaxExpLevel][LvlName], Max_Exp_Lvl_Name, "%s", t[2]);
      MaxExpLevel++;
   }
   MaxExpLevel--;
   if(MaxExpLevel>0)
	 for(new i=0; i<=MaxExpLevel; i++)
	 {
		format(tmp1, sizeof(tmp1), "ExpDiffWhenKill_%d", i);
        ExpforDiffLvl[i] = dini_Int(ExpLvlsPatch,tmp1);
     }
   return;
}

GetPlayerExpLevel(playerid)
{
	new playerLvl = 0;
	for(new i = 0; i < MaxExpLevel; i++)
	{
		if(PlayerParams[playerid][Experience] >= ExpLevels[i][MaxExpForNextLvl]) playerLvl = i+1;
		else break;
	}
	return playerLvl;
}

GetPlayerExpName(playerid)
{
   new tmp[50];
   new pLvl = GetPlayerExpLevel(playerid);
   format(tmp, sizeof(tmp), "%s", ExpLevels[pLvl][LvlName]);
   return tmp;
}

GetExpForKill(LvlKiller, LvlKilling)
{
   new DiffLvl = LvlKilling - LvlKiller;
   if(DiffLvl <= 0) return ExpforDiffLvl[0];
   if(DiffLvl > MaxExpLevel) return ExpforDiffLvl[MaxExpLevel];
   return ExpforDiffLvl[DiffLvl];
}

HowMuchMoneyAdd(playerid)
{
   if(PlayerParams[playerid][AdminLvl] >= ALvlForNonMoneyMaxVerify) return 100000000;
   new hmm = GetPlayerMaxMoney(playerid) - GetPlayerMoneyEx(playerid);
   if(hmm < 0) hmm = 0;
   return hmm;
}

GetPlayerMaxMoney(playerid)
{
	if(PlayerParams[playerid][isGold]) return ExpLevels[MaxExpLevel][MaxMoneyForLvls];
	//
	new lvl = GetPlayerExpLevel(playerid);
	if(lvl < 0) lvl = 0;
	return ExpLevels[lvl][MaxMoneyForLvls];
}

IncPlayerExp(playerid, exp)
{
   new addedExp = 0;
   if(PlayerParams[playerid][isGold])
   {
      addedExp = floatround(float(exp)*0.2);
      if(addedExp < 1) addedExp = 1;
   }
   PlayerParams[playerid][Experience] += exp + addedExp;
   new tmp[20];
   if(PlayerParams[playerid][isGold]) format(tmp, sizeof(tmp), "exp: +%d(+%d) [%d]; ", exp, addedExp, PlayerParams[playerid][Experience]);
   else format(tmp, sizeof(tmp), "exp: +%d [%d]", exp, PlayerParams[playerid][Experience]);
   GameTextForPlayer(playerid, tmp, 1000, 1);
   CallRemoteFunction("EReg_ChangeExp", "ddd", playerid, PlayerParams[playerid][Experience], GetPlayerExpLevel(playerid));
}

public AddPlayerMoneyEx(playerid, money)
{
	 new hma = HowMuchMoneyAdd(playerid);
	 if(money > hma) money = hma;
     PlayerParams[playerid][AddedMoney] += money;
}

//      (     )
MegaAddPlayerMoney(PlayerID_BD, money)
{
    new playerid = GetPlayeridByBDID(PlayerID_BD);
    if(playerid != -1)
	    AddPlayerMoneyEx(playerid, money);
    else
    {
	   new cm[255];
	   format(cm, sizeof(cm), "UPDATE mainParam SET money=money+%d WHERE id=%d", money, PlayerID_BD);
	   DB_Update(cm);
    }
}

public SetPlayerMoneyEx(playerid, money)
{
   new maxMoney = GetPlayerMaxMoney(playerid);
   if(money > maxMoney) money = maxMoney;
   PlayerParams[playerid][AddedMoney] = money-PlayerParams[playerid][OldPlayerMoney];
}

GetPlayerMoneyEx(playerid)
{
   return PlayerParams[playerid][OldPlayerMoney] + PlayerParams[playerid][AddedMoney];
}

public missions(playerid, mission, mon, Float:dist)
{
   if(!IsPlayerConnected(playerid)) return 1;
   AddPlayerMoneyEx(playerid, mon);
   if(PlayerParams[playerid][IsPlayerLogined] == 0) return 1;
   if(mission == 1)//
   {
	  new exp = floatround(floatdiv(dist, 350.0));
	  if(exp > 0) IncPlayerExp(playerid, exp);
      PlayerParams[playerid][TruckerMiss]++;
      setMissionStatInBD(PlayerParams[playerid][id_BD], 0, PlayerParams[playerid][TruckerMiss]);
   }
   if(mission == 2)// 
   {
      new exp = floatround(floatdiv(mon, 400.0));
	  if(exp > 0) IncPlayerExp(playerid, exp);
	  PlayerParams[playerid][BusMiss]++;
	  setMissionStatInBD(PlayerParams[playerid][id_BD], 1, PlayerParams[playerid][BusMiss]);
   }
   if(mission == 3)//cashBox
   {
      IncPlayerExp(playerid, 5);
      PlayerParams[playerid][CashBox]++;
      setMissionStatInBD(PlayerParams[playerid][id_BD], 4, PlayerParams[playerid][CashBox]);
   }
   if(mission == 4)//train
   {
      IncPlayerExp(playerid, 30);
      PlayerParams[playerid][trainMiss]++;
      setMissionStatInBD(PlayerParams[playerid][id_BD], 3, PlayerParams[playerid][trainMiss]);
   }
   if(mission == 5)//export
   {
      IncPlayerExp(playerid, 10);
      PlayerParams[playerid][CarExportMiss]++;
      setMissionStatInBD(PlayerParams[playerid][id_BD], 2, PlayerParams[playerid][CarExportMiss]);
   }
   if(mission == 6)//taxi
   {
      PlayerParams[playerid][taxiMiss]++;
	  new exp = IntDiv(mon, 100);
	  if(exp < 1) exp = 1;
	  if(mon < 100) exp=0;
	  else
	   if(MissionDescr[playerid][wages] > 0)
	    if((IntDiv(MissionDescr[playerid][wages], 10)*10) == MissionDescr[playerid][wages])
	    {
	      exp+=25;
	      AddPlayerMoneyEx(playerid, 20000);
	      SendPlayerModText(playerid, "     25   20000$  10   ", taxiPassengersListClr);
	    }
	  //
      IncPlayerExp(playerid, exp);
      setMissionStatInBD(PlayerParams[playerid][id_BD], 5, PlayerParams[playerid][taxiMiss]);
   }
   return 1;
}
